/*
ļʵiicĻ
ĿǰC51,C251,STM32׼⻷ʹ
ߣj2536353578
*/

#ifndef _IIC_H_
#define _IIC_H_
#ifndef uchar
#define uchar unsigned char
#endif
#ifndef uint
#define uint unsigned int
#endif
//stm32
#ifdef USE_STDPERIPH_DRIVER
	//ʱscl/sda
	//ʾiic_set(oled,scl,0);
	#define iic_set(iic_name,iic_type,dat) \
		if(dat)iic_name.iic_type##_gpio->BSRR=iic_name.iic_type##_pin;\
		else iic_name.iic_type##_gpio->BRR=iic_name.iic_type##_pin
	//˿
	//ʾiic_def(oled,GPIOA,GPIO_Pin_0,GPIOA,GPIO_Pin_1);
	#define iic_def(iic_name,scl_gpio,scl_pin,sda_gpio,sda_pin,del) \
	IIC_TYPE iic_name={scl_gpio,scl_pin,sda_gpio,sda_pin,del}

//c51
#else
	//ʱscl / sda / iicٶ
	//ʾiic_set(oled,scl,0);
	#define iic_set(iic_name,iic_type,dat) iic_name##_##iic_type=dat;
	//˿
	//ʾiic_def(oled,P2^0,P2^1);
	#define iic_def(iic_name,scl,sda,del)	\
		sbit iic_name##_scl=scl;						\
		sbit iic_name##_sda=sda;						\
		unsigned int edata iic_name##_delay=del
#endif

void iic_delay(unsigned int i){while(i--);}

#ifdef USE_STDPERIPH_DRIVER
	#include "stm32f10x.h"
	typedef struct{
		GPIO_TypeDef* scl_gpio;
		int16_t scl_pin;
		GPIO_TypeDef* sda_gpio;
		int16_t sda_pin;
		uint delay;
	}IIC_TYPE;
	void iic_ack(IIC_TYPE iic,uchar ack)
	{
		iic_set(iic,scl,0);iic_delay(iic.delay);
		iic_set(iic,sda,ack);iic_delay(iic.delay);
		iic_set(iic,scl,1);iic_delay(iic.delay);
		iic_set(iic,scl,0);iic_delay(iic.delay);
	}
	void iic_start(IIC_TYPE iic)
	{
		iic_set(iic,scl,0);iic_delay(iic.delay);
		iic_set(iic,sda,1);iic_delay(iic.delay);
		iic_set(iic,scl,1);iic_delay(iic.delay);
		iic_set(iic,sda,0);iic_delay(iic.delay);
		iic_set(iic,scl,0);iic_delay(iic.delay);
	}
	void iic_end(IIC_TYPE iic)
	{
		iic_set(iic,scl,0);iic_delay(iic.delay);
		iic_set(iic,sda,0);iic_delay(iic.delay);
		iic_set(iic,scl,1);iic_delay(iic.delay);
		iic_set(iic,sda,1);iic_delay(iic.delay);
	}
	void iic_send(IIC_TYPE iic,uchar dat)
	{
		uchar i=0;
		for(i=0;i<8;i++)
		{
			iic_set(iic,scl,0);iic_delay(iic.delay);
			if(dat&0x80){iic_set(iic,sda,1);}
			else {iic_set(iic,sda,0);}
			iic_delay(iic.delay);iic_set(iic,scl,1);
			iic_delay(iic.delay);dat<<=1;
		}
		iic_ack(iic,0);
	}

	uchar iic_recv(IIC_TYPE iic)
	{
		uchar i,dat=0;
		iic_set(iic,scl,0);iic_delay(iic.delay);
		iic_set(iic,sda,1);iic_delay(iic.delay);
		for(i=0;i<8;i++)
		{
			iic_set(iic,scl,0);dat<<=1;
			iic_delay(iic.delay);
			iic_set(iic,scl,1);iic_delay(iic.delay);
			dat|=(iic.scl_gpio->IDR&iic.scl_pin)?1:0;
			iic_delay(iic.delay);
		}
		iic_ack(iic,1);
		return dat;
	}

#else

	unsigned char edata iic_i=0,iic_dat=0;
	#define iic_ack(iic_name,ack)						 			\
		iic_name##_scl=0;iic_delay(iic_name##_delay);		\
		iic_name##_sda=ack;iic_delay(iic_name##_delay);	\
		iic_name##_scl=1;iic_delay(iic_name##_delay);	 	\
		iic_name##_scl=0;iic_delay(iic_name##_delay)

	#define iic_start(iic_name)									\
		iic_name##_scl=0;iic_delay(iic_name##_delay); \
		iic_name##_sda=1;iic_delay(iic_name##_delay); \
		iic_name##_scl=1;iic_delay(iic_name##_delay); \
		iic_name##_sda=0;iic_delay(iic_name##_delay); \
		iic_name##_scl=0;iic_delay(iic_name##_delay)

	#define iic_end(iic_name)										\
		iic_name##_scl=0;iic_delay(iic_name##_delay);	\
		iic_name##_sda=0;iic_delay(iic_name##_delay);	\
		iic_name##_scl=1;iic_delay(iic_name##_delay);	\
		iic_name##_sda=1;iic_delay(iic_name##_delay)

	#define iic_send(iic_name,dat)									\
		iic_dat=dat;															\
		for(iic_i=0;iic_i<8;iic_i++)							\
		{																					\
			iic_name##_scl=0;iic_delay(iic_name##_delay);		\
			iic_name##_sda=(iic_dat&0x80)?1:0;					\
			iic_delay(iic_name##_delay);iic_name##_scl=1;		\
			iic_delay(iic_name##_delay);iic_dat<<=1;		\
		}																					\
		iic_ack(iic_name##,1)
		
	#define iic_recv(iic_name,dat)																\
		dat=0;iic_name##_scl=0;iic_delay(iic_name##_delay);							\
		iic_name##_sda=1;iic_delay(iic_name##_delay);										\
		for(iic_i=0;iic_i<8;iic_i++)														\
		{																												\
			iic_name##_scl=0;dat<<=1;iic_delay(iic_name##_delay);					\
			iic_name##_scl=1;dat|=iic_name##_sda;iic_delay(iic_name##_delay); \
		}																												\
		iic_ack(iic_name##,1)
#endif
#endif

